# Installing GCC: Configuration

Like most GNU software, GCC must be configured before it can be built. This document describes the recommended configuration procedure for both native and cross targets.

We use srcdir to refer to the toplevel source directory for GCC; we use objdir to refer to the toplevel build/object directory.

If you obtained the sources via CVS, srcdir must refer to the top `gcc` directory, the one where the `MAINTAINERS` can be found, and not its `gcc` subdirectory, otherwise the build will fail.

If either srcdir or objdir is located on an automounted NFS file system, the shell's built-in `pwd` command will return temporary pathnames. Using these can lead to various sorts of build problems. To avoid this issue, set the `PWDCMD` environment variable to an automounter-aware `pwd` command, e.g., `pawd` or `amq -w`, during the configuration and build phases.

First, we highly recommend that GCC be built into a separate directory than the sources which does not reside within the source tree. This is how we generally build GCC; building where srcdir == objdir should still work, but doesn't get extensive testing; building where objdir is a subdirectory of srcdir is unsupported.

If you have previously built GCC in the same directory for a different target machine, do `make distclean` to delete all files that might be invalid. One of the files this deletes is `Makefile`; if `make distclean` complains that `Makefile` does not exist or issues a message like "don't know how to make distclean" it probably means that the directory is already suitably clean. However, with the recommended method of building in a separate objdir, you should simply use a different objdir for each target.

Second, when configuring a native system, either `cc` or `gcc` must be in your path or you must set `CC` in your environment before running configure. Otherwise the configuration scripts may fail.

Note that the bootstrap compiler and the resulting GCC must be link compatible, else the bootstrap will fail with linker errors about incompatible object file formats. Several multilibed targets are affected by this requirement, see host/target specific installation notes.

To configure GCC:

       % mkdir objdir
       % cd objdir
       % srcdir/configure [options] [target]

### Target specification

- GCC has code to correctly determine the correct value for target for nearly all native systems. Therefore, we highly recommend you not provide a configure target when configuring a native compiler.
- target must be specified as `--target=target` when configuring a cross compiler; examples of valid targets would be i960-rtems, m68k-coff, sh-elf, etc.
- Specifying just target instead of `--target=target` implies that the host defaults to target.

### Options specification

Use options to override several configure time options for GCC. A list of supported options follows; `configure --help` may list other options, but those not listed below may not work and should not normally be used.

Note that each `--enable` option has a corresponding `--disable` option and that each `--with` option has a corresponding `--without` option.

`--prefix=dirname`
  Specify the toplevel installation directory. This is the recommended way to install the tools into a directory other than the default. The toplevel installation directory defaults to `/usr/local`.

  We highly recommend against dirname being the same or a subdirectory of objdir or vice versa. If specifying a directory beneath a user's home directory tree, some shells will not expand dirname correctly if it contains the `~` metacharacter; use `$HOME` instead.

  The following standard `autoconf` options are supported. Normally you should not need to use these options.

  `--exec-prefix=dirname`
    Specify the toplevel installation directory for architecture-dependent files. The default is `prefix`.
  `--bindir=dirname`
    Specify the installation directory for the executables called by users (such as `gcc` and `g++`). The default is `exec-prefix/bin`.
  `--libdir=dirname`
    Specify the installation directory for object code libraries and internal data files of GCC. The default is `exec-prefix/lib`.
  `--libexecdir=dirname`
    Specify the installation directory for internal executables of GCC. The default is `exec-prefix/libexec`.
  `--with-slibdir=dirname`
    Specify the installation directory for the shared libgcc library. The default is `libdir`.
  `--infodir=dirname`
    Specify the installation directory for documentation in info format. The default is `prefix/info`.
  `--datadir=dirname`
    Specify the installation directory for some architecture-independent data files referenced by GCC. The default is `prefix/share`.
  `--mandir=dirname`
    Specify the installation directory for manual pages. The default is `prefix/man`. (Note that the manual pages are only extracts from the full GCC manuals, which are provided in Texinfo format. The manpages are derived by an automatic conversion process from parts of the full manual.)
  `--with-gxx-include-dir=dirname`
    Specify the installation directory for G++ header files. The default is `prefix/include/c++/version`.
`--program-prefix=prefix`
  GCC supports some transformations of the names of its programs when installing them. This option prepends prefix to the names of programs to install in bindir (see above). For example, specifying `--program-prefix=foo-` would result in `gcc` being installed as `/usr/local/bin/foo-gcc`.
`--program-suffix=suffix`
  Appends suffix to the names of programs to install in bindir (see above). For example, specifying `--program-suffix=-3.1` would result in `gcc` being installed as `/usr/local/bin/gcc-3.1`.
`--program-transform-name=pattern`
  Applies the `sed` script pattern to be applied to the names of programs to install in bindir (see above). pattern has to consist of one or more basic `sed` editing commands, separated by semicolons. For example, if you want the `gcc` program name to be transformed to the installed program `/usr/local/bin/myowngcc` and the `g++` program name to be transformed to `/usr/local/bin/gspecial++` without changing other program names, you could use the pattern `--program-transform-name='s/^gcc$/myowngcc/; s/^g++$/gspecial++/'` to achieve this effect.

  All three options can be combined and used together, resulting in more complex conversion patterns. As a basic rule, prefix (and suffix) are prepended (appended) before further transformations can happen with a special transformation script pattern.

  As currently implemented, this option only takes effect for native builds; cross compiler binaries' names are not transformed even when a transformation is explicitly asked for by one of these options.

  For native builds, some of the installed programs are also installed with the target alias in front of their name, as in `i686-pc-linux-gnu-gcc`. All of the above transformations happen before the target alias is prepended to the name - so, specifying `--program-prefix=foo-` and `program-suffix=-3.1`, the resulting binary would be installed as `/usr/local/bin/i686-pc-linux-gnu-foo-gcc-3.1`.

  As a last shortcoming, none of the installed Ada programs are transformed yet, which will be fixed in some time.

`--with-local-prefix=dirname`
  Specify the installation directory for local include files. The default is `/usr/local`. Specify this option if you want the compiler to search directory `dirname/include` for locally installed header files instead of `/usr/local/include`.

  You should specify `--with-local-prefix` only if your site has a different convention (not `/usr/local`) for where to put site-specific files.

  The default value for `--with-local-prefix` is `/usr/local` regardless of the value of `--prefix`. Specifying `--prefix` has no effect on which directory GCC searches for local header files. This may seem counterintuitive, but actually it is logical.

  The purpose of `--prefix` is to specify where to install GCC. The local header files in `/usr/local/include`--if you put any in that directory--are not part of GCC. They are part of other programs--perhaps many others. (GCC installs its own header files in another directory which is based on the `--prefix` value.)

  Both the local-prefix include directory and the GCC-prefix include directory are part of GCC's "system include" directories. Although these two directories are not fixed, they need to be searched in the proper order for the correct processing of the include_next directive. The local-prefix include directory is searched before the GCC-prefix include directory. Another characteristic of system include directories is that pedantic warnings are turned off for headers in these directories.

  Some autoconf macros add `-I directory` options to the compiler command line, to ensure that directories containing installed packages' headers are searched. When directory is one of GCC's system include directories, GCC will ignore the option so that system directories continue to be processed in the correct order. This may result in a search order different from what was specified but the directory will still be searched.

  GCC automatically searches for ordinary libraries using `GCC_EXEC_PREFIX`. Thus, when the same installation prefix is used for both GCC and packages, GCC will automatically search for both headers and libraries. This provides a configuration that is easy to use. GCC behaves in a manner similar to that when it is installed as a system compiler in `/usr`.

  Sites that need to install multiple versions of GCC may not want to use the above simple configuration. It is possible to use the `--program-prefix`, `--program-suffix` and `--program-transform-name` options to install multiple versions into a single directory, but it may be simpler to use different prefixes and the `--with-local-prefix` option to specify the location of the site-specific files for each version. It will then be necessary for users to specify explicitly the location of local site libraries (e.g., with `LIBRARY_PATH`).

  The same value can be used for both `--with-local-prefix` and `--prefix` provided it is not `/usr`. This can be used to avoid the default search of `/usr/local/include`.

  Do not specify `/usr` as the `--with-local-prefix`! The directory you use for `--with-local-prefix` must not contain any of the system's standard header files. If it did contain them, certain programs would be miscompiled (including GNU Emacs, on certain targets), because this would override and nullify the header file corrections made by the `fixincludes` script.

  Indications are that people who use this option use it based on mistaken ideas of what it is for. People use it as if it specified where to install part of GCC. Perhaps they make this assumption because installing GCC creates the directory.

`--enable-shared[=package[,...]]`
  Build shared versions of libraries, if shared libraries are supported on the target platform. Unlike GCC 2.95.x and earlier, shared libraries are enabled by default on all platforms that support shared libraries, except for `libobjc` which is built as a static library only by default.

  If a list of packages is given as an argument, build shared libraries only for the listed packages. For other packages, only static libraries will be built. Package names currently recognized in the GCC tree are `libgcc` (also known as `gcc`), `libstdc++` (not `libstdc++-v3`), `libffi`, `zlib`, `boehm-gc` and `libjava`. Note that `libobjc` does not recognize itself by any name, so, if you list package names in `--enable-shared`, you will only get static Objective-C libraries. `libf2c` and `libiberty` do not support shared libraries at all.

  Use `--disable-shared` to build only static libraries. Note that `--disable-shared` does not accept a list of package names as argument, only `--enable-shared` does.

`--with-gnu-as`
  Specify that the compiler should assume that the assembler it finds is the GNU assembler. However, this does not modify the rules to find an assembler and will result in confusion if the assembler found is not actually the GNU assembler. (Confusion may also result if the compiler finds the GNU assembler but has not been configured with `--with-gnu-as`.) If you have more than one assembler installed on your system, you may want to use this option in connection with `--with-as=pathname`.

  The following systems are the only ones where it makes a difference whether you use the GNU assembler. On any other system, `--with-gnu-as` has no effect.

  - `hppa1.0-any-any`
  - `hppa1.1-any-any`
  - `i386-any-sysv`
  - `m68k-bull-sysv`
  - `m68k-hp-hpux`
  - `m68000-hp-hpux`
  - `m68000-att-sysv`
  - `any-lynx-lynxos`
  - `mips-any`
  - `sparc-sun-solaris2.any`
  - `sparc64-any-solaris2.any`

  On the systems listed above (except for the HP-PA, the SPARC, for ISC on the 386, and for `mips-sgi-irix5.*`), if you use the GNU assembler, you should also use the GNU linker (and specify `--with-gnu-ld`).

`--with-as=pathname`
  Specify that the compiler should use the assembler pointed to by pathname, rather than the one found by the standard rules to find an assembler, which are:
  - Check the `libexec/gcc/target/version` directory, where libexec defaults to `exec-prefix/libexec` and exec-prefix defaults to prefix which defaults to `/usr/local` unless overridden by the `--prefix=pathname` switch described above. target is the target system triple, such as `sparc-sun-solaris2.7`, and version denotes the GCC version, such as 3.0.
  - Check operating system specific directories (e.g. `/usr/ccs/bin` on Sun Solaris 2).
  Note that these rules do not check for the value of `PATH`. You may want to use `--with-as` if no assembler is installed in the directories listed above, or if you have multiple assemblers installed and want to choose one that is not found by the above rules.
`--with-gnu-ld`
  Same as `--with-gnu-as` but for the linker.
`--with-ld=pathname`
  Same as `--with-as` but for the linker.
`--with-stabs`
  Specify that stabs debugging information should be used instead of whatever format the host normally uses. Normally GCC uses the same debug format as the host system.

  On MIPS based systems and on Alphas, you must specify whether you want GCC to create the normal ECOFF debugging format, or to use BSD-style stabs passed through the ECOFF symbol table. The normal ECOFF debug format cannot fully handle languages other than C. BSD stabs format can handle other languages, but it only works with the GNU debugger GDB.

  Normally, GCC uses the ECOFF debugging format by default; if you prefer BSD stabs, specify `--with-stabs` when you configure GCC.

  No matter which default you choose when you configure GCC, the user can use the `-gcoff` and `-gstabs+` options to specify explicitly the debug format for a particular compilation.

  `--with-stabs` is meaningful on the ISC system on the 386, also, if `--with-gas` is used. It selects use of stabs debugging information embedded in COFF output. This kind of debugging information supports C++ well; ordinary COFF debugging information does not.

  `--with-stabs` is also meaningful on 386 systems running SVR4. It selects use of stabs debugging information embedded in ELF output. The C++ compiler currently (2.6.0) does not support the DWARF debugging information normally used on 386 SVR4 platforms; stabs provide a workable alternative. This requires gas and gdb, as the normal SVR4 tools can not generate or interpret stabs.

`--disable-multilib`
  Specify that multiple target libraries to support different target variants, calling conventions, etc should not be built. The default is to build a predefined set of them.

  Some targets provide finer-grained control over which multilibs are built (e.g., `--disable-softfloat`):

  `arc-*-elf*`
    biendian.
  `arm-*-*`
    fpu, 26bit, underscore, interwork, biendian, nofmult.
  `m68*-*-*`
    softfloat, m68881, m68000, m68020.
  `mips*-*-*`
    single-float, biendian, softfloat.
  `powerpc*-*-*, rs6000*-*-*`
    aix64, pthread, softfloat, powercpu, powerpccpu, powerpcos, biendian, sysv, aix.
`--enable-threads`
  Specify that the target supports threads. This affects the Objective-C compiler and runtime library, and exception handling for other languages like C++ and Java. On some systems, this is the default.

  In general, the best (and, in many cases, the only known) threading model available will be configured for use. Beware that on some systems, GCC has not been taught what threading models are generally available for the system. In this case, `--enable-threads` is an alias for `--enable-threads=single`.

`--disable-threads`
  Specify that threading support should be disabled for the system. This is an alias for `--enable-threads=single`.
`--enable-threads=lib`
  Specify that lib is the thread support library. This affects the Objective-C compiler and runtime library, and exception handling for other languages like C++ and Java. The possibilities for lib are:
  `aix`
    AIX thread support.
  `dce`
    DCE thread support.
  `gnat`
    Ada tasking support. For non-Ada programs, this setting is equivalent to `single`. When used in conjunction with the Ada run time, it causes GCC to use the same thread primitives as Ada uses. This option is necessary when using both Ada and the back end exception handling, which is the default for most Ada targets.
  `mach`
    Generic MACH thread support, known to work on NeXTSTEP. (Please note that the file needed to support this configuration, `gthr-mach.h`, is missing and thus this setting will cause a known bootstrap failure.)
  `no`
    This is an alias for `single`.
  `posix`
    Generic POSIX thread support.
  `rtems`
    RTEMS thread support.
  `single`
    Disable thread support, should work for all platforms.
  `solaris`
    Sun Solaris 2 thread support.
  `vxworks`
    VxWorks thread support.
  `win32`
    Microsoft Win32 API thread support.
`--with-cpu=cpu`
  Specify which cpu variant the compiler should generate code for by default. cpu will be used as the default value of the `-mcpu=` switch. This option is only supported on some targets, including ARM, i386, PowerPC, and SPARC.
`--with-schedule=cpu`
`--with-arch=cpu`
`--with-tune=cpu`
`--with-abi=abi`
`--with-float=type`
  These configure options provide default values for the `-mschedule=`, `-march=`, `-mtune=`, and `-mabi=` options and for `-mhard-float` or `-msoft-float`. As with `--with-cpu`, which switches will be accepted and acceptable values of the arguments depend on the target.
`--enable-altivec`
  Specify that the target supports AltiVec vector enhancements. This option will adjust the ABI for AltiVec enhancements, as well as generate AltiVec code when appropriate. This option is only available for PowerPC systems.
`--enable-__cxa_atexit`
  Define if you want to use __cxa_atexit, rather than atexit, to register C++ destructors for local statics and global objects. This is essential for fully standards-compliant handling of destructors, but requires __cxa_atexit in libc. This option is currently only available on systems with GNU libc. When enabled, this will cause `-fuse-cxa-exit` to be passed by default.
`--enable-target-optspace`
  Specify that target libraries should be optimized for code space instead of code speed. This is the default for the m32r platform.
`--disable-cpp`
  Specify that a user visible `cpp` program should not be installed.
`--with-cpp-install-dir=dirname`
  Specify that the user visible `cpp` program should be installed in `prefix/dirname/cpp`, in addition to bindir.
`--enable-initfini-array`
  Force the use of sections `.init_array` and `.fini_array` (instead of `.init` and `.fini`) for constructors and destructors. Option `--disable-initfini-array` has the opposite effect. If neither option is specified, the configure script will try to guess whether the `.init_array` and `.fini_array` sections are supported and, if they are, use them.
`--enable-maintainer-mode`
  The build rules that regenerate the GCC master message catalog `gcc.pot` are normally disabled. This is because it can only be rebuilt if the complete source tree is present. If you have changed the sources and want to rebuild the catalog, configuring with `--enable-maintainer-mode` will enable this. Note that you need a recent version of the `gettext` tools to do so.
`--enable-generated-files-in-srcdir`
  Neither the .c and .h files that are generated from bison and flex nor the info manuals and man pages that are built from the .texi files are present in the CVS development tree. When building GCC from that development tree, or from a snapshot which are created from CVS, then those generated files are placed in your build directory, which allows for the source to be in a readonly directory.

  If you configure with `--enable-generated-files-in-srcdir` then those generated files will go into the source directory. This is mainly intended for generating release or prerelease tarballs of the GCC sources, since it is not a requirement that the users of source releases to have flex, bison, or makeinfo.

`--enable-version-specific-runtime-libs`
  Specify that runtime libraries should be installed in the compiler specific subdirectory (`libdir/gcc`) rather than the usual places. In addition, `libstdc++`'s include files will be installed into `libdir` unless you overruled it by using `--with-gxx-include-dir=dirname`. Using this option is particularly useful if you intend to use several versions of GCC in parallel. This is currently supported by `libf2c` and `libstdc++`, and is the default for `libobjc` which cannot be changed in this case.
`--enable-languages=lang1,lang2,...`
  Specify that only a particular subset of compilers and their runtime libraries should be built. For a list of valid values for langN you can issue the following command in the `gcc` directory of your GCC source tree:

      grep language= */config-lang.in

  Currently, you can use any of the following: `ada`, `c`, `c++`, `f77`, `java`, `objc`. Building the Ada compiler has special requirements, see below.
  If you do not pass this flag, all languages available in the `gcc` sub-tree will be configured. Re-defining `LANGUAGES` when calling `make bootstrap` does not work anymore, as those language sub-directories might not have been configured!
`--with-dwarf2`
  Specify that the compiler should use DWARF 2 debugging information as the default.
`--enable-win32-registry`
`--enable-win32-registry=key`
`--disable-win32-registry`
  The `--enable-win32-registry` option enables Microsoft Windows-hosted GCC to look up installations paths in the registry using the following key:

      HKEY_LOCAL_MACHINE\SOFTWARE\Free Software Foundation\key

  key defaults to GCC version number, and can be overridden by the `--enable-win32-registry=key` option. Vendors and distributors who use custom installers are encouraged to provide a different key, perhaps one comprised of vendor name and GCC version number, to avoid conflict with existing installations. This feature is enabled by default, and can be disabled by `--disable-win32-registry` option. This option has no effect on the other hosts.

`--nfp`
  Specify that the machine does not have a floating point unit. This option only applies to `m68k-sun-sunosn`. On any other system, `--nfp` has no effect.
`--enable-werror`
`--disable-werror`
`--enable-werror=yes`
`--enable-werror=no`
  When you specify this option, it controls whether certain files in the compiler are built with `-Werror` in bootstrap stage2 and later. If you don't specify it, `-Werror` is turned on for the main development trunk. However it defaults to off for release branches and final releases. The specific files which get `-Werror` are controlled by the Makefiles.
`--enable-checking`
`--enable-checking=list`
  When you specify this option, the compiler is built to perform checking of tree node types when referencing fields of that node, and some other internal consistency checks. This does not change the generated code, but adds error checking within the compiler. This will slow down the compiler and may only work properly if you are building the compiler with GCC. This is on by default when building from CVS or snapshots, but off for releases. More control over the checks may be had by specifying list; the categories of checks available are `misc`, `tree`, `gc`, `rtl`, `rtlflag`, `fold`, `gcac` and `valgrind`. The check `valgrind` requires the external `valgrind` simulator, available from http://valgrind.kde.org/. The default when list is not specified is `misc,tree,gc,rtlflag`; the checks `rtl`, `gcac` and `valgrind` are very expensive.
`--enable-coverage`
`--enable-coverage=level`
  With this option, the compiler is built to collect self coverage information, every time it is run. This is for internal development purposes, and only works when the compiler is being built with gcc. The level argument controls whether the compiler is built optimized or not, values are `opt` and `noopt`. For coverage analysis you want to disable optimization, for performance analysis you want to enable optimization. When coverage is enabled, the default level is without optimization.
`--enable-gather-detailed-mem-stats`
  When this option is specified more detailed information on memory allocation is gathered. This information is printed when using `-fmem-report`.
`--enable-nls`
`--disable-nls`
  The `--enable-nls` option enables Native Language Support (NLS), which lets GCC output diagnostics in languages other than American English. Native Language Support is enabled by default if not doing a canadian cross build. The `--disable-nls` option disables NLS.
`--with-included-gettext`
  If NLS is enabled, the `--with-included-gettext` option causes the build procedure to prefer its copy of GNU `gettext`.
`--with-catgets`
  If NLS is enabled, and if the host lacks `gettext` but has the inferior `catgets` interface, the GCC build procedure normally ignores `catgets` and instead uses GCC's copy of the GNU `gettext` library. The `--with-catgets` option causes the build procedure to use the host's `catgets` in this situation.
`--with-libiconv-prefix=dir`
  Search for libiconv header files in `dir/include` and libiconv library files in `dir/lib`.
`--enable-obsolete`
  Enable configuration for an obsoleted system. If you attempt to configure GCC for a system (build, host, or target) which has been obsoleted, and you do not specify this flag, configure will halt with an error message.

  All support for systems which have been obsoleted in one release of GCC is removed entirely in the next major release, unless someone steps forward to maintain the port.

#### Cross-Compiler-Specific Options

The following options only apply to building cross compilers.

`--with-sysroot`
`--with-sysroot=dir`
  Tells GCC to consider dir as the root of a tree that contains a (subset of) the root filesystem of the target operating system. Target system headers, libraries and run-time object files will be searched in there. The specified directory is not copied into the install tree, unlike the options `--with-headers` and `--with-libs` that this option obsoletes. The default value, in case `--with-sysroot` is not given an argument, is `${gcc_tooldir}/sys-root`. If the specified directory is a subdirectory of `${exec_prefix}`, then it will be found relative to the GCC binaries if the installation tree is moved.
`--with-headers`
`--with-headers=dir`
  Deprecated in favor of `--with-sysroot`. Specifies that target headers are available when building a cross compiler. The dir argument specifies a directory which has the target include files. These include files will be copied into the `gcc` install directory. This option with the dir argument is required when building a cross compiler, if `prefix/target/sys-include` doesn't pre-exist. If `prefix/target/sys-include` does pre-exist, the dir argument may be omitted. `fixincludes` will be run on these files to make them compatible with GCC.
`--without-headers`
  Tells GCC not use any target headers from a libc when building a cross compiler. When crossing to GNU/Linux, you need the headers so GCC can build the exception handling for libgcc. See CrossGCC for more information on this option.
`--with-libs`
`--with-libs=``dir1 dir2 ... dirN''`
  Deprecated in favor of `--with-sysroot`. Specifies a list of directories which contain the target runtime libraries. These libraries will be copied into the `gcc` install directory. If the directory list is omitted, this option has no effect.
`--with-newlib`
  Specifies that `newlib` is being used as the target C library. This causes `__eprintf` to be omitted from `libgcc.a` on the assumption that it will be provided by `newlib`.

#### Java-Specific Options

The following option applies to the build of the Java front end.

`--disable-libgcj`
  Specify that the run-time libraries used by GCJ should not be built. This is useful in case you intend to use GCJ with some other run-time, or you're going to install it separately, or it just happens not to build on your particular machine. In general, if the Java front end is enabled, the GCJ libraries will be enabled too, unless they're known to not work on the target platform. If GCJ is enabled but `libgcj` isn't built, you may need to port it; in this case, before modifying the top-level `configure.in` so that `libgcj` is enabled by default on this platform, you may use `--enable-libgcj` to override the default.

The following options apply to building `libgcj`.

##### General Options

`--disable-getenv-properties`
  Don't set system properties from `GCJ_PROPERTIES`.
`--enable-hash-synchronization`
  Use a global hash table for monitor locks. Ordinarily, `libgcj`'s `configure` script automatically makes the correct choice for this option for your platform. Only use this if you know you need the library to be configured differently.
`--enable-interpreter`
  Enable the Java interpreter. The interpreter is automatically enabled by default on all platforms that support it. This option is really only useful if you want to disable the interpreter (using `--disable-interpreter`).
`--disable-java-net`
  Disable java.net. This disables the native part of java.net only, using non-functional stubs for native method implementations.
`--disable-jvmpi`
  Disable JVMPI support.
`--with-ecos`
  Enable runtime eCos target support.
`--without-libffi`
  Don't use `libffi`. This will disable the interpreter and JNI support as well, as these require `libffi` to work.
`--enable-libgcj-debug`
  Enable runtime debugging code.
`--enable-libgcj-multifile`
  If specified, causes all `.java` source files to be compiled into `.class` files in one invocation of `gcj`. This can speed up build time, but is more resource-intensive. If this option is unspecified or disabled, `gcj` is invoked once for each `.java` file to compile into a `.class` file.
`--with-libiconv-prefix=DIR`
  Search for libiconv in `DIR/include` and `DIR/lib`.
`--enable-sjlj-exceptions`
  Force use of `builtin_setjmp` for exceptions. `configure` ordinarily picks the correct value based on the platform. Only use this option if you are sure you need a different setting.
`--with-system-zlib`
  Use installed `zlib` rather than that included with GCC.
`--with-win32-nlsapi=ansi, unicows or unicode`
  Indicates how MinGW `libgcj` translates between UNICODE characters and the Win32 API.
  `ansi`
    Use the single-byte `char` and the Win32 A functions natively, translating to and from UNICODE when using these functions. If unspecified, this is the default.
  `unicows`
    Use the `WCHAR` and Win32 W functions natively. Adds `-lunicows` to `libgcj.spec` to link with `libunicows`. `unicows.dll` needs to be deployed on Microsoft Windows 9X machines running built executables. `libunicows.a`, an open-source import library around Microsoft's `unicows.dll`, is obtained from http://libunicows.sourceforge.net/, which also gives details on getting `unicows.dll` from Microsoft.
  `unicode`
    Use the `WCHAR` and Win32 W functions natively. Does not add `-lunicows` to `libgcj.spec`. The built executables will only run on Microsoft Windows NT and above.

##### AWT-Specific Options

`--with-x`
  Use the X Window System.
`--enable-java-awt=PEER(S)`
  Specifies the AWT peer library or libraries to build alongside `libgcj`. If this option is unspecified or disabled, AWT will be non-functional. Current valid values are `gtk` and `xlib`. Multiple libraries should be separated by a comma (i.e. `--enable-java-awt=gtk,xlib`).
`--enable-gtk-cairo`
  Build the cairo Graphics2D implementation on GTK.
`--enable-java-gc=TYPE`
  Choose garbage collector. Defaults to `boehm` if unspecified.
`--disable-gtktest`
  Do not try to compile and run a test GTK+ program.
`--disable-glibtest`
  Do not try to compile and run a test GLIB program.
`--with-libart-prefix=PFX`
  Prefix where libart is installed (optional).
`--with-libart-exec-prefix=PFX`
  Exec prefix where libart is installed (optional).
`--disable-libarttest`
  Do not try to compile and run a test libart program.

Return to the GCC Installation page